/* A Bison parser, made by GNU Bison 3.7.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30705

/* Bison version string.  */
#define YYBISON_VERSION "3.7.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         mpparse
#define yylex           mplex
#define yyerror         mperror
#define yydebug         mpdebug
#define yynerrs         mpnerrs
#define yylval          mplval
#define yychar          mpchar

/* First part of user prologue.  */
#line 1 "parser.y"

/*
 * Copyright 2001, THE AUTHOR <mibparser@cvtt.net>
 * All rights reserved.
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *  
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *  
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * A parser for the basic grammar to use for snmp V2c modules
 */

#ifdef _WIN32
#pragma warning(disable : 4065 4102)
#endif

/*
#ifndef __STDC__
#define __STDC__	1
#endif
*/

#define YYMALLOC	MemAlloc
#define YYFREE		MemFree

#include <nms_common.h>
#include <nms_util.h>
#include <string.h>
#include <time.h>
#include "mibparse.h"
#include "nxmibc.h"
#include "nxsnmp.h"

#define YYINCLUDED_STDLIB_H		1

#ifdef YYTEXT_POINTER
extern char *mptext;
#else
extern char mptext[];
#endif

#ifdef __64BIT__
#define YYSIZE_T  int64_t
#endif

extern FILE *mpin, *mpout;
extern int g_nCurrLine;

static MP_MODULE *m_pModule;
static MP_SYNTAX *s_currentSyntaxObject = nullptr;
#ifdef UNICODE
static char s_currentFilename[MAX_PATH];
#else
static const char *s_currentFilename;
#endif

int mperror(const char *pszMsg);
int mplex(void);
void ResetScanner();

MP_SYNTAX *create_std_syntax(int nSyntax)
{
   MP_SYNTAX *p = new MP_SYNTAX;
   p->nSyntax = nSyntax;
   return p;
}

static int AccessFromText(const char *pszText)
{
   static const char *pText[] = { "read-only", "read-write", "write-only",
                                  "not-accessible", "accessible-for-notify",
                                  "read-create", nullptr };
   for(int i = 0; pText[i] != nullptr; i++)
      if (strcmp(pszText, pText[i]))
         return i + 1;

   char szBuffer[256];
   sprintf(szBuffer, "Invalid ACCESS value \"%s\"", pszText);
   mperror(szBuffer);
   return -1;
}


#line 187 "parser.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ENTERPRISE_SYM = 3,             /* ENTERPRISE_SYM  */
  YYSYMBOL_TRAP_TYPE_SYM = 4,              /* TRAP_TYPE_SYM  */
  YYSYMBOL_VARIABLES_SYM = 5,              /* VARIABLES_SYM  */
  YYSYMBOL_EXPLICIT_SYM = 6,               /* EXPLICIT_SYM  */
  YYSYMBOL_IMPLICIT_SYM = 7,               /* IMPLICIT_SYM  */
  YYSYMBOL_IMPLIED_SYM = 8,                /* IMPLIED_SYM  */
  YYSYMBOL_RIGHT_BRACE_SYM = 9,            /* RIGHT_BRACE_SYM  */
  YYSYMBOL_LEFT_BRACE_SYM = 10,            /* LEFT_BRACE_SYM  */
  YYSYMBOL_RIGHT_BRACKET_SYM = 11,         /* RIGHT_BRACKET_SYM  */
  YYSYMBOL_LEFT_BRACKET_SYM = 12,          /* LEFT_BRACKET_SYM  */
  YYSYMBOL_DEFINITIONS_SYM = 13,           /* DEFINITIONS_SYM  */
  YYSYMBOL_ASSIGNMENT_SYM = 14,            /* ASSIGNMENT_SYM  */
  YYSYMBOL_BEGIN_SYM = 15,                 /* BEGIN_SYM  */
  YYSYMBOL_END_SYM = 16,                   /* END_SYM  */
  YYSYMBOL_FROM_SYM = 17,                  /* FROM_SYM  */
  YYSYMBOL_IMPORTS_SYM = 18,               /* IMPORTS_SYM  */
  YYSYMBOL_EXPORTS_SYM = 19,               /* EXPORTS_SYM  */
  YYSYMBOL_COMMA_SYM = 20,                 /* COMMA_SYM  */
  YYSYMBOL_SEMI_COLON_SYM = 21,            /* SEMI_COLON_SYM  */
  YYSYMBOL_DOT_SYM = 22,                   /* DOT_SYM  */
  YYSYMBOL_DESCRIPTION_SYM = 23,           /* DESCRIPTION_SYM  */
  YYSYMBOL_ORGANIZATION_SYM = 24,          /* ORGANIZATION_SYM  */
  YYSYMBOL_CONTACT_SYM = 25,               /* CONTACT_SYM  */
  YYSYMBOL_UPDATE_SYM = 26,                /* UPDATE_SYM  */
  YYSYMBOL_MODULE_IDENTITY_SYM = 27,       /* MODULE_IDENTITY_SYM  */
  YYSYMBOL_MODULE_COMPLIANCE_SYM = 28,     /* MODULE_COMPLIANCE_SYM  */
  YYSYMBOL_OBJECT_IDENTIFIER_SYM = 29,     /* OBJECT_IDENTIFIER_SYM  */
  YYSYMBOL_OBJECT_TYPE_SYM = 30,           /* OBJECT_TYPE_SYM  */
  YYSYMBOL_OBJECT_GROUP_SYM = 31,          /* OBJECT_GROUP_SYM  */
  YYSYMBOL_OBJECT_IDENTITY_SYM = 32,       /* OBJECT_IDENTITY_SYM  */
  YYSYMBOL_OBJECTS_SYM = 33,               /* OBJECTS_SYM  */
  YYSYMBOL_MANDATORY_GROUPS_SYM = 34,      /* MANDATORY_GROUPS_SYM  */
  YYSYMBOL_GROUP_SYM = 35,                 /* GROUP_SYM  */
  YYSYMBOL_AGENT_CAPABILITIES_SYM = 36,    /* AGENT_CAPABILITIES_SYM  */
  YYSYMBOL_KEYWORD_SYM = 37,               /* KEYWORD_SYM  */
  YYSYMBOL_KEYWORD_VALUE_SYM = 38,         /* KEYWORD_VALUE_SYM  */
  YYSYMBOL_KEYWORD_BIND_SYM = 39,          /* KEYWORD_BIND_SYM  */
  YYSYMBOL_TOKEN_SYM = 40,                 /* TOKEN_SYM  */
  YYSYMBOL_INTEGER_SYM = 41,               /* INTEGER_SYM  */
  YYSYMBOL_INTEGER32_SYM = 42,             /* INTEGER32_SYM  */
  YYSYMBOL_UNSIGNED32_SYM = 43,            /* UNSIGNED32_SYM  */
  YYSYMBOL_GAUGE32_SYM = 44,               /* GAUGE32_SYM  */
  YYSYMBOL_COUNTER_SYM = 45,               /* COUNTER_SYM  */
  YYSYMBOL_COUNTER32_SYM = 46,             /* COUNTER32_SYM  */
  YYSYMBOL_COUNTER64_SYM = 47,             /* COUNTER64_SYM  */
  YYSYMBOL_BITS_SYM = 48,                  /* BITS_SYM  */
  YYSYMBOL_STRING_SYM = 49,                /* STRING_SYM  */
  YYSYMBOL_OCTET_SYM = 50,                 /* OCTET_SYM  */
  YYSYMBOL_SEQUENCE_SYM = 51,              /* SEQUENCE_SYM  */
  YYSYMBOL_OF_SYM = 52,                    /* OF_SYM  */
  YYSYMBOL_TIMETICKS_SYM = 53,             /* TIMETICKS_SYM  */
  YYSYMBOL_IP_ADDRESS_SYM = 54,            /* IP_ADDRESS_SYM  */
  YYSYMBOL_NETWORK_ADDRESS_SYM = 55,       /* NETWORK_ADDRESS_SYM  */
  YYSYMBOL_OPAQUE_SYM = 56,                /* OPAQUE_SYM  */
  YYSYMBOL_REVISION_SYM = 57,              /* REVISION_SYM  */
  YYSYMBOL_TEXTUAL_CONVENTION_SYM = 58,    /* TEXTUAL_CONVENTION_SYM  */
  YYSYMBOL_ACCESS_SYM = 59,                /* ACCESS_SYM  */
  YYSYMBOL_MAX_ACCESS_SYM = 60,            /* MAX_ACCESS_SYM  */
  YYSYMBOL_MIN_ACCESS_SYM = 61,            /* MIN_ACCESS_SYM  */
  YYSYMBOL_SYNTAX_SYM = 62,                /* SYNTAX_SYM  */
  YYSYMBOL_STATUS_SYM = 63,                /* STATUS_SYM  */
  YYSYMBOL_INDEX_SYM = 64,                 /* INDEX_SYM  */
  YYSYMBOL_REFERENCE_SYM = 65,             /* REFERENCE_SYM  */
  YYSYMBOL_DEFVAL_SYM = 66,                /* DEFVAL_SYM  */
  YYSYMBOL_DISPLAY_HINT_SYM = 67,          /* DISPLAY_HINT_SYM  */
  YYSYMBOL_LEFT_PAREN_SYM = 68,            /* LEFT_PAREN_SYM  */
  YYSYMBOL_RIGHT_PAREN_SYM = 69,           /* RIGHT_PAREN_SYM  */
  YYSYMBOL_NOTIFICATIONS_SYM = 70,         /* NOTIFICATIONS_SYM  */
  YYSYMBOL_NOTIFICATION_GROUP_SYM = 71,    /* NOTIFICATION_GROUP_SYM  */
  YYSYMBOL_NOTIFICATION_TYPE_SYM = 72,     /* NOTIFICATION_TYPE_SYM  */
  YYSYMBOL_SIZE_SYM = 73,                  /* SIZE_SYM  */
  YYSYMBOL_BAR_SYM = 74,                   /* BAR_SYM  */
  YYSYMBOL_VARIATION_SYM = 75,             /* VARIATION_SYM  */
  YYSYMBOL_WRITE_SYNTAX_SYM = 76,          /* WRITE_SYNTAX_SYM  */
  YYSYMBOL_SUPPORTS_SYM = 77,              /* SUPPORTS_SYM  */
  YYSYMBOL_INCLUDES_SYM = 78,              /* INCLUDES_SYM  */
  YYSYMBOL_CREATION_REQUIRES_SYM = 79,     /* CREATION_REQUIRES_SYM  */
  YYSYMBOL_PRODUCT_RELEASE_SYM = 80,       /* PRODUCT_RELEASE_SYM  */
  YYSYMBOL_CHOICE_SYM = 81,                /* CHOICE_SYM  */
  YYSYMBOL_UNITS_SYM = 82,                 /* UNITS_SYM  */
  YYSYMBOL_AUGMENTS_SYM = 83,              /* AUGMENTS_SYM  */
  YYSYMBOL_OBJECT_SYM = 84,                /* OBJECT_SYM  */
  YYSYMBOL_TAGS_SYM = 85,                  /* TAGS_SYM  */
  YYSYMBOL_AUTOMATIC_SYM = 86,             /* AUTOMATIC_SYM  */
  YYSYMBOL_MIN_SYM = 87,                   /* MIN_SYM  */
  YYSYMBOL_MAX_SYM = 88,                   /* MAX_SYM  */
  YYSYMBOL_MODULE_SYM = 89,                /* MODULE_SYM  */
  YYSYMBOL_MACRO_SYM = 90,                 /* MACRO_SYM  */
  YYSYMBOL_UCASEFIRST_IDENT_SYM = 91,      /* UCASEFIRST_IDENT_SYM  */
  YYSYMBOL_LCASEFIRST_IDENT_SYM = 92,      /* LCASEFIRST_IDENT_SYM  */
  YYSYMBOL_BSTRING_SYM = 93,               /* BSTRING_SYM  */
  YYSYMBOL_HSTRING_SYM = 94,               /* HSTRING_SYM  */
  YYSYMBOL_CSTRING_SYM = 95,               /* CSTRING_SYM  */
  YYSYMBOL_NUMBER_SYM = 96,                /* NUMBER_SYM  */
  YYSYMBOL_YYACCEPT = 97,                  /* $accept  */
  YYSYMBOL_ModuleDefinition = 98,          /* ModuleDefinition  */
  YYSYMBOL_AssignmentList = 99,            /* AssignmentList  */
  YYSYMBOL_Assignment = 100,               /* Assignment  */
  YYSYMBOL_ModuleIdentifierAssignment = 101, /* ModuleIdentifierAssignment  */
  YYSYMBOL_ModuleIdentifier = 102,         /* ModuleIdentifier  */
  YYSYMBOL_ObjectIdentifierAssignment = 103, /* ObjectIdentifierAssignment  */
  YYSYMBOL_AssignedIdentifier = 104,       /* AssignedIdentifier  */
  YYSYMBOL_AssignedIdentifierList = 105,   /* AssignedIdentifierList  */
  YYSYMBOL_ObjectIdentifierList = 106,     /* ObjectIdentifierList  */
  YYSYMBOL_ObjectIdentifier = 107,         /* ObjectIdentifier  */
  YYSYMBOL_NumericValue = 108,             /* NumericValue  */
  YYSYMBOL_NumberOrMinMax = 109,           /* NumberOrMinMax  */
  YYSYMBOL_DefinedValue = 110,             /* DefinedValue  */
  YYSYMBOL_Number = 111,                   /* Number  */
  YYSYMBOL_ObjectIdentityAssignment = 112, /* ObjectIdentityAssignment  */
  YYSYMBOL_ObjectTypeAssignment = 113,     /* ObjectTypeAssignment  */
  YYSYMBOL_ModuleIdentityAssignment = 114, /* ModuleIdentityAssignment  */
  YYSYMBOL_ImportsAssignment = 115,        /* ImportsAssignment  */
  YYSYMBOL_ExportsAssignment = 116,        /* ExportsAssignment  */
  YYSYMBOL_SnmpRevisionPart = 117,         /* SnmpRevisionPart  */
  YYSYMBOL_SnmpRevisionList = 118,         /* SnmpRevisionList  */
  YYSYMBOL_SnmpRevisionObject = 119,       /* SnmpRevisionObject  */
  YYSYMBOL_SnmpIdentityPart = 120,         /* SnmpIdentityPart  */
  YYSYMBOL_SnmpOrganisationPart = 121,     /* SnmpOrganisationPart  */
  YYSYMBOL_SnmpContactInfoPart = 122,      /* SnmpContactInfoPart  */
  YYSYMBOL_SnmpUpdatePart = 123,           /* SnmpUpdatePart  */
  YYSYMBOL_SnmpDescriptionPart = 124,      /* SnmpDescriptionPart  */
  YYSYMBOL_SnmpDescriptionStatement = 125, /* SnmpDescriptionStatement  */
  YYSYMBOL_ValueConstraint = 126,          /* ValueConstraint  */
  YYSYMBOL_NumericValueConstraintList = 127, /* NumericValueConstraintList  */
  YYSYMBOL_DanglingComma = 128,            /* DanglingComma  */
  YYSYMBOL_SnmpKeywordAssignment = 129,    /* SnmpKeywordAssignment  */
  YYSYMBOL_SnmpKeywordName = 130,          /* SnmpKeywordName  */
  YYSYMBOL_SnmpKeywordValue = 131,         /* SnmpKeywordValue  */
  YYSYMBOL_SnmpKeywordBinding = 132,       /* SnmpKeywordBinding  */
  YYSYMBOL_SnmpSyntaxPart = 133,           /* SnmpSyntaxPart  */
  YYSYMBOL_SnmpSyntaxStatement = 134,      /* SnmpSyntaxStatement  */
  YYSYMBOL_SnmpUnitsPart = 135,            /* SnmpUnitsPart  */
  YYSYMBOL_SnmpWriteSyntaxPart = 136,      /* SnmpWriteSyntaxPart  */
  YYSYMBOL_SnmpCreationPart = 137,         /* SnmpCreationPart  */
  YYSYMBOL_TypeOrValueAssignment = 138,    /* TypeOrValueAssignment  */
  YYSYMBOL_Type = 139,                     /* Type  */
  YYSYMBOL_NamedType = 140,                /* NamedType  */
  YYSYMBOL_BuiltInType = 141,              /* BuiltInType  */
  YYSYMBOL_BuiltInTypeAssignment = 142,    /* BuiltInTypeAssignment  */
  YYSYMBOL_TypeOrTextualConvention = 143,  /* TypeOrTextualConvention  */
  YYSYMBOL_MacroAssignment = 144,          /* MacroAssignment  */
  YYSYMBOL_TokenList = 145,                /* TokenList  */
  YYSYMBOL_TokenObject = 146,              /* TokenObject  */
  YYSYMBOL_TextualConventionAssignment = 147, /* TextualConventionAssignment  */
  YYSYMBOL_TextualConventionDefinition = 148, /* TextualConventionDefinition  */
  YYSYMBOL_TextualConventionDefinitionElement = 149, /* TextualConventionDefinitionElement  */
  YYSYMBOL_SnmpNotificationTypeAssignment = 150, /* SnmpNotificationTypeAssignment  */
  YYSYMBOL_SnmpTrapVariablePart = 151,     /* SnmpTrapVariablePart  */
  YYSYMBOL_SnmpTrapVariableList = 152,     /* SnmpTrapVariableList  */
  YYSYMBOL_SnmpMandatoryGroupPart = 153,   /* SnmpMandatoryGroupPart  */
  YYSYMBOL_SnmpMandatoryGroupList = 154,   /* SnmpMandatoryGroupList  */
  YYSYMBOL_SnmpMandatoryGroup = 155,       /* SnmpMandatoryGroup  */
  YYSYMBOL_SnmpCompliancePart = 156,       /* SnmpCompliancePart  */
  YYSYMBOL_SnmpComplianceList = 157,       /* SnmpComplianceList  */
  YYSYMBOL_SnmpComplianceObject = 158,     /* SnmpComplianceObject  */
  YYSYMBOL_SnmpObjectsPart = 159,          /* SnmpObjectsPart  */
  YYSYMBOL_SnmpObjectGroupAssignment = 160, /* SnmpObjectGroupAssignment  */
  YYSYMBOL_SnmpNotificationGroupAssignment = 161, /* SnmpNotificationGroupAssignment  */
  YYSYMBOL_ModuleComplianceAssignment = 162, /* ModuleComplianceAssignment  */
  YYSYMBOL_SnmpModuleComplianceList = 163, /* SnmpModuleComplianceList  */
  YYSYMBOL_SnmpModuleComplianceObject = 164, /* SnmpModuleComplianceObject  */
  YYSYMBOL_OptionalModuleName = 165,       /* OptionalModuleName  */
  YYSYMBOL_SnmpVariationsListPart = 166,   /* SnmpVariationsListPart  */
  YYSYMBOL_SnmpVariationsList = 167,       /* SnmpVariationsList  */
  YYSYMBOL_SnmpVariationPart = 168,        /* SnmpVariationPart  */
  YYSYMBOL_ModuleCapabilitiesList = 169,   /* ModuleCapabilitiesList  */
  YYSYMBOL_ModuleCapabilitiesAssignment = 170, /* ModuleCapabilitiesAssignment  */
  YYSYMBOL_AgentCapabilitiesAssignment = 171, /* AgentCapabilitiesAssignment  */
  YYSYMBOL_SnmpAccessPart = 172,           /* SnmpAccessPart  */
  YYSYMBOL_SnmpStatusPart = 173,           /* SnmpStatusPart  */
  YYSYMBOL_SnmpReferencePart = 174,        /* SnmpReferencePart  */
  YYSYMBOL_SnmpReferenceStatement = 175,   /* SnmpReferenceStatement  */
  YYSYMBOL_SnmpDisplayHintStatement = 176, /* SnmpDisplayHintStatement  */
  YYSYMBOL_SnmpIndexPart = 177,            /* SnmpIndexPart  */
  YYSYMBOL_SnmpDefValPart = 178,           /* SnmpDefValPart  */
  YYSYMBOL_DefValList = 179,               /* DefValList  */
  YYSYMBOL_DefValListElement = 180,        /* DefValListElement  */
  YYSYMBOL_BinaryString = 181,             /* BinaryString  */
  YYSYMBOL_HexString = 182,                /* HexString  */
  YYSYMBOL_CharString = 183,               /* CharString  */
  YYSYMBOL_SymbolsFromModuleList = 184,    /* SymbolsFromModuleList  */
  YYSYMBOL_SymbolsFromModule = 185,        /* SymbolsFromModule  */
  YYSYMBOL_SymbolList = 186,               /* SymbolList  */
  YYSYMBOL_Symbol = 187,                   /* Symbol  */
  YYSYMBOL_SequenceItem = 188,             /* SequenceItem  */
  YYSYMBOL_SequenceList = 189,             /* SequenceList  */
  YYSYMBOL_SequenceAssignment = 190,       /* SequenceAssignment  */
  YYSYMBOL_SnmpTypeTagPart = 191,          /* SnmpTypeTagPart  */
  YYSYMBOL_SnmpTypeTagList = 192,          /* SnmpTypeTagList  */
  YYSYMBOL_SnmpTypeTagItem = 193,          /* SnmpTypeTagItem  */
  YYSYMBOL_OctetStringType = 194,          /* OctetStringType  */
  YYSYMBOL_Value = 195,                    /* Value  */
  YYSYMBOL_Identifier = 196,               /* Identifier  */
  YYSYMBOL_UCidentifier = 197,             /* UCidentifier  */
  YYSYMBOL_LCidentifier = 198,             /* LCidentifier  */
  YYSYMBOL_End = 199,                      /* End  */
  YYSYMBOL_Begin = 200                     /* Begin  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   454

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  97
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  228
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  436

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   351


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   267,   267,   268,   272,   273,   277,   281,   285,   289,
     293,   297,   301,   302,   306,   310,   311,   315,   319,   320,
     324,   332,   336,   343,   354,   364,   368,   382,   389,   395,
     404,   411,   419,   430,   431,   435,   436,   443,   444,   445,
     449,   456,   463,   470,   490,   521,   539,   547,   554,   555,
     559,   560,   564,   573,   580,   587,   594,   601,   606,   612,
     619,   620,   621,   625,   626,   627,   631,   635,   639,   640,
     641,   645,   652,   659,   666,   671,   678,   685,   689,   693,
     697,   701,   705,   709,   724,   740,   756,   763,   770,   777,
     787,   791,   795,   799,   806,   815,   819,   823,   827,   831,
     835,   839,   843,   847,   851,   856,   860,   867,   872,   877,
     882,   887,   892,   897,   902,   907,   915,   919,   926,   936,
     937,   941,   945,   953,   954,   958,   959,   960,   972,   973,
     991,  1012,  1051,  1052,  1056,  1063,  1064,  1068,  1069,  1073,
    1080,  1081,  1085,  1086,  1090,  1100,  1108,  1112,  1113,  1117,
    1118,  1122,  1140,  1157,  1171,  1172,  1176,  1182,  1186,  1190,
    1191,  1195,  1196,  1200,  1215,  1216,  1220,  1225,  1233,  1253,
    1258,  1263,  1269,  1275,  1297,  1298,  1302,  1309,  1316,  1320,
    1326,  1332,  1333,  1334,  1338,  1342,  1343,  1347,  1351,  1352,
    1356,  1360,  1364,  1371,  1378,  1385,  1390,  1398,  1405,  1409,
    1417,  1421,  1425,  1432,  1440,  1441,  1445,  1449,  1450,  1454,
    1455,  1459,  1466,  1467,  1468,  1469,  1470,  1471,  1472,  1476,
    1477,  1478,  1479,  1486,  1490,  1497,  1504,  1511,  1515
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ENTERPRISE_SYM",
  "TRAP_TYPE_SYM", "VARIABLES_SYM", "EXPLICIT_SYM", "IMPLICIT_SYM",
  "IMPLIED_SYM", "RIGHT_BRACE_SYM", "LEFT_BRACE_SYM", "RIGHT_BRACKET_SYM",
  "LEFT_BRACKET_SYM", "DEFINITIONS_SYM", "ASSIGNMENT_SYM", "BEGIN_SYM",
  "END_SYM", "FROM_SYM", "IMPORTS_SYM", "EXPORTS_SYM", "COMMA_SYM",
  "SEMI_COLON_SYM", "DOT_SYM", "DESCRIPTION_SYM", "ORGANIZATION_SYM",
  "CONTACT_SYM", "UPDATE_SYM", "MODULE_IDENTITY_SYM",
  "MODULE_COMPLIANCE_SYM", "OBJECT_IDENTIFIER_SYM", "OBJECT_TYPE_SYM",
  "OBJECT_GROUP_SYM", "OBJECT_IDENTITY_SYM", "OBJECTS_SYM",
  "MANDATORY_GROUPS_SYM", "GROUP_SYM", "AGENT_CAPABILITIES_SYM",
  "KEYWORD_SYM", "KEYWORD_VALUE_SYM", "KEYWORD_BIND_SYM", "TOKEN_SYM",
  "INTEGER_SYM", "INTEGER32_SYM", "UNSIGNED32_SYM", "GAUGE32_SYM",
  "COUNTER_SYM", "COUNTER32_SYM", "COUNTER64_SYM", "BITS_SYM",
  "STRING_SYM", "OCTET_SYM", "SEQUENCE_SYM", "OF_SYM", "TIMETICKS_SYM",
  "IP_ADDRESS_SYM", "NETWORK_ADDRESS_SYM", "OPAQUE_SYM", "REVISION_SYM",
  "TEXTUAL_CONVENTION_SYM", "ACCESS_SYM", "MAX_ACCESS_SYM",
  "MIN_ACCESS_SYM", "SYNTAX_SYM", "STATUS_SYM", "INDEX_SYM",
  "REFERENCE_SYM", "DEFVAL_SYM", "DISPLAY_HINT_SYM", "LEFT_PAREN_SYM",
  "RIGHT_PAREN_SYM", "NOTIFICATIONS_SYM", "NOTIFICATION_GROUP_SYM",
  "NOTIFICATION_TYPE_SYM", "SIZE_SYM", "BAR_SYM", "VARIATION_SYM",
  "WRITE_SYNTAX_SYM", "SUPPORTS_SYM", "INCLUDES_SYM",
  "CREATION_REQUIRES_SYM", "PRODUCT_RELEASE_SYM", "CHOICE_SYM",
  "UNITS_SYM", "AUGMENTS_SYM", "OBJECT_SYM", "TAGS_SYM", "AUTOMATIC_SYM",
  "MIN_SYM", "MAX_SYM", "MODULE_SYM", "MACRO_SYM", "UCASEFIRST_IDENT_SYM",
  "LCASEFIRST_IDENT_SYM", "BSTRING_SYM", "HSTRING_SYM", "CSTRING_SYM",
  "NUMBER_SYM", "$accept", "ModuleDefinition", "AssignmentList",
  "Assignment", "ModuleIdentifierAssignment", "ModuleIdentifier",
  "ObjectIdentifierAssignment", "AssignedIdentifier",
  "AssignedIdentifierList", "ObjectIdentifierList", "ObjectIdentifier",
  "NumericValue", "NumberOrMinMax", "DefinedValue", "Number",
  "ObjectIdentityAssignment", "ObjectTypeAssignment",
  "ModuleIdentityAssignment", "ImportsAssignment", "ExportsAssignment",
  "SnmpRevisionPart", "SnmpRevisionList", "SnmpRevisionObject",
  "SnmpIdentityPart", "SnmpOrganisationPart", "SnmpContactInfoPart",
  "SnmpUpdatePart", "SnmpDescriptionPart", "SnmpDescriptionStatement",
  "ValueConstraint", "NumericValueConstraintList", "DanglingComma",
  "SnmpKeywordAssignment", "SnmpKeywordName", "SnmpKeywordValue",
  "SnmpKeywordBinding", "SnmpSyntaxPart", "SnmpSyntaxStatement",
  "SnmpUnitsPart", "SnmpWriteSyntaxPart", "SnmpCreationPart",
  "TypeOrValueAssignment", "Type", "NamedType", "BuiltInType",
  "BuiltInTypeAssignment", "TypeOrTextualConvention", "MacroAssignment",
  "TokenList", "TokenObject", "TextualConventionAssignment",
  "TextualConventionDefinition", "TextualConventionDefinitionElement",
  "SnmpNotificationTypeAssignment", "SnmpTrapVariablePart",
  "SnmpTrapVariableList", "SnmpMandatoryGroupPart",
  "SnmpMandatoryGroupList", "SnmpMandatoryGroup", "SnmpCompliancePart",
  "SnmpComplianceList", "SnmpComplianceObject", "SnmpObjectsPart",
  "SnmpObjectGroupAssignment", "SnmpNotificationGroupAssignment",
  "ModuleComplianceAssignment", "SnmpModuleComplianceList",
  "SnmpModuleComplianceObject", "OptionalModuleName",
  "SnmpVariationsListPart", "SnmpVariationsList", "SnmpVariationPart",
  "ModuleCapabilitiesList", "ModuleCapabilitiesAssignment",
  "AgentCapabilitiesAssignment", "SnmpAccessPart", "SnmpStatusPart",
  "SnmpReferencePart", "SnmpReferenceStatement",
  "SnmpDisplayHintStatement", "SnmpIndexPart", "SnmpDefValPart",
  "DefValList", "DefValListElement", "BinaryString", "HexString",
  "CharString", "SymbolsFromModuleList", "SymbolsFromModule", "SymbolList",
  "Symbol", "SequenceItem", "SequenceList", "SequenceAssignment",
  "SnmpTypeTagPart", "SnmpTypeTagList", "SnmpTypeTagItem",
  "OctetStringType", "Value", "Identifier", "UCidentifier", "LCidentifier",
  "End", "Begin", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351
};
#endif

#define YYPACT_NINF (-347)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-225)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -47,  -347,    70,   257,  -347,    35,  -347,  -347,     6,     6,
      61,   118,   124,   129,   145,   167,   172,   177,   180,   182,
     185,  -347,   257,  -347,  -347,  -347,  -347,  -347,  -347,  -347,
     150,  -347,    87,  -347,  -347,  -347,  -347,  -347,  -347,  -347,
    -347,   133,   199,   152,  -347,   228,   112,    38,  -347,   140,
    -347,  -347,  -347,   218,   149,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   253,  -347,  -347,   149,   248,   260,
     264,  -347,   254,   290,   282,   235,   242,   123,   170,    10,
    -347,   242,   123,   229,   123,  -347,    -2,  -347,  -347,  -347,
     -47,     6,  -347,  -347,  -347,   -47,   246,   162,  -347,     9,
       9,  -347,  -347,   323,   310,  -347,  -347,  -347,  -347,  -347,
    -347,  -347,  -347,  -347,  -347,   284,  -347,   149,   300,   149,
     317,  -347,   112,    18,  -347,    39,   249,  -347,   112,   305,
     322,   326,   201,    33,   327,  -347,  -347,  -347,  -347,  -347,
    -347,  -347,  -347,  -347,  -347,   188,   327,  -347,  -347,   305,
     242,   149,   242,   255,  -347,  -347,  -347,   237,   310,   149,
     149,   149,  -347,  -347,   162,  -347,  -347,  -347,  -347,   227,
     158,  -347,  -347,   291,   117,  -347,  -347,  -347,  -347,  -347,
    -347,  -347,  -347,  -347,   293,  -347,  -347,  -347,  -347,  -347,
    -347,  -347,  -347,  -347,  -347,    20,  -347,  -347,   149,   305,
    -347,     6,   338,  -347,   149,   201,  -347,   279,  -347,    32,
      48,   112,   112,   112,   242,   190,  -347,  -347,     3,  -347,
    -347,  -347,   277,   324,   286,  -347,   279,   305,   242,   305,
     253,   339,  -347,   190,  -347,  -347,  -347,  -347,  -347,  -347,
    -347,   334,  -347,  -347,     5,   289,   294,     5,   309,  -347,
     331,  -347,  -347,  -347,  -347,   318,    53,   371,   305,  -347,
    -347,   242,   282,  -347,  -347,    73,  -347,   141,  -347,  -347,
    -347,   305,  -347,   164,    39,  -347,  -347,   237,   112,   295,
     279,   305,   279,  -347,  -347,   360,   227,   227,   379,   -49,
     227,   320,  -347,  -347,   149,   282,   318,  -347,  -347,     6,
     279,   305,  -347,  -347,  -347,   279,  -347,   190,  -347,   332,
    -347,   -47,    12,  -347,   282,   279,   282,   -49,  -347,  -347,
    -347,   333,     5,  -347,   305,  -347,  -347,   186,   282,   279,
     282,  -347,  -347,   357,  -347,  -347,  -347,  -347,   -42,  -347,
    -347,  -347,   335,  -347,  -347,  -347,   -14,  -347,   393,    -6,
     357,  -347,   -47,   328,    51,  -347,   336,   397,   398,   343,
       6,   112,   112,  -347,    -6,  -347,  -347,   340,     6,  -347,
    -347,  -347,     6,   190,   400,   282,   189,   305,   235,  -347,
     401,    11,   217,   403,   324,  -347,    24,  -347,  -347,  -347,
    -347,   341,     6,   112,  -347,   344,  -347,  -347,  -347,    63,
     232,  -347,   404,   407,   411,    15,    39,   201,   238,   235,
    -347,  -347,   247,  -347,   413,  -347,  -347,  -347,  -347,  -347,
     305,   344,   341,  -347,  -347,  -347,  -347,   201,   342,   414,
     343,     6,   305,   250,  -347,  -347
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   225,     0,     0,    20,     0,     1,   227,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   226,     0,     5,     6,     7,     8,    17,    18,    19,
       0,    15,    68,    10,    83,     9,    11,    14,    13,    12,
      16,     0,   223,   224,     3,     0,     0,     0,   196,     0,
     199,   200,   201,     0,     0,   208,   208,   208,   208,   208,
     208,   208,   208,   208,     0,     4,     2,     0,     0,     0,
       0,    69,     0,     0,     0,    75,     0,   150,   208,     0,
      53,     0,   150,     0,   150,    24,     0,   202,    46,   195,
       0,     0,    47,   194,    71,     0,     0,     0,   116,    91,
      90,   109,   117,     0,   207,   210,   110,   115,   112,   113,
     114,   111,   107,   108,   228,     0,    56,     0,     0,     0,
       0,    70,     0,     0,    23,   208,    78,    74,     0,    58,
       0,     0,   172,     0,     0,   192,   193,    42,   219,    85,
      84,   221,   220,   222,    89,     0,     0,    25,    26,    58,
       0,     0,     0,     0,    21,   197,   198,     0,   208,     0,
       0,     0,   127,   129,   122,   124,   126,   128,   125,     0,
       0,    93,    92,     0,     0,   105,    95,    97,    98,   102,
      99,   100,   101,   218,     0,   103,   215,   216,   217,   106,
      94,   223,   224,   209,   121,     0,   120,    54,     0,    58,
      72,     0,   133,    76,     0,   172,   173,   175,    57,     0,
       0,     0,     0,     0,     0,     0,    86,    88,     0,    29,
      31,    30,     0,   223,    41,    87,   175,    58,     0,    58,
       0,     0,   104,     0,    59,   176,   177,   123,    38,    39,
      65,    33,    34,    37,    67,     0,     0,    67,     0,    96,
       0,   212,   119,   118,    55,    49,     0,     0,    58,   132,
      77,     0,     0,   174,   147,     0,   149,     0,   169,   170,
     171,    58,   204,     0,   208,    27,    28,     0,     0,     0,
     175,    58,   175,    22,   211,     0,    66,     0,     0,     0,
       0,     0,   213,   214,     0,     0,    48,    51,    73,     0,
     175,    58,    43,   146,   148,   175,   206,     0,   203,     0,
      40,   158,     0,   155,     0,   175,     0,     0,    64,    63,
      62,     0,    67,    60,    58,    45,    50,     0,     0,   175,
       0,   205,    32,   136,   157,   153,   154,   151,     0,   152,
      35,    36,     0,    52,   134,   131,   180,   130,     0,   141,
     135,   138,     0,     0,     0,   165,     0,     0,     0,   187,
       0,     0,     0,   156,   140,   143,   137,     0,     0,   168,
     164,    61,     0,     0,     0,     0,     0,    58,    75,   142,
       0,   160,     0,     0,     0,    41,     0,   186,    44,   139,
     145,    80,     0,     0,   167,   159,   162,   178,   179,     0,
       0,   189,     0,     0,     0,     0,   208,   172,     0,    75,
     161,   191,     0,   185,     0,   181,   182,   183,   184,    79,
      58,   160,    80,   190,   188,   144,   166,   172,    82,     0,
     187,     0,    58,     0,   163,    81
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -347,  -347,  -347,   405,  -347,   425,  -347,   -59,    52,  -347,
     210,    34,  -259,  -138,   -69,  -347,  -347,  -347,  -347,  -347,
    -347,  -347,   134,  -347,  -347,  -347,  -347,   -94,   -30,   329,
    -159,  -230,  -347,  -347,   359,  -347,  -346,   -23,  -347,    13,
    -347,  -347,   -72,   274,  -347,  -347,   337,  -347,  -347,   239,
     355,  -347,   272,  -347,  -347,  -347,  -347,  -347,    88,  -347,
    -347,    75,    90,  -347,  -347,  -347,  -347,   125,  -347,    19,
    -347,    46,  -347,    89,  -347,  -187,   -39,  -193,   -16,  -347,
    -347,    14,  -347,    28,    59,    60,   -51,  -347,   402,    -9,
     356,   143,  -347,   -82,   296,  -347,   347,  -347,  -347,     0,
       1,    -1,   -17,   -78
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,    22,    23,     3,   353,    24,    85,   147,   218,
     219,   240,   241,   242,   243,    25,    26,    27,    28,    29,
     295,   296,   297,    30,   118,   199,    68,   207,   208,   171,
     244,   288,    31,    32,    71,    72,   126,   127,   205,   407,
     430,    33,    98,    99,   100,    34,   101,    35,   195,   196,
     102,   164,   165,    36,   258,   259,   349,   350,   351,   363,
     364,   365,   132,    37,    38,    39,   312,   313,   333,   394,
     395,   396,   354,   355,    40,   214,   166,   262,   263,   168,
     359,   375,   400,   401,   141,   142,    94,    47,    48,    49,
      50,   272,   273,   216,   103,   104,   105,   189,   144,   245,
      51,    52,    44,   115
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      53,     5,    43,    41,    42,    66,   139,   220,   154,   138,
     148,   247,   275,   114,    46,   124,   116,   291,   261,   169,
     145,    43,    41,    42,   418,   286,   123,   143,   145,   361,
     321,    91,   391,   279,   399,   352,     7,   129,   238,   239,
      46,   264,   149,   215,     1,    87,    46,   137,    45,     1,
     357,    95,   217,   203,   148,   226,    46,   266,   340,    88,
     194,   146,   298,   422,   225,   123,   197,   162,   200,   358,
       6,    46,   411,    91,   163,    54,   221,   170,   362,   287,
     220,   167,   303,   277,   153,   158,   393,   314,   231,   316,
      96,   155,   342,    91,     1,    21,   157,     1,    21,   137,
     228,   311,   192,   190,   191,   255,   137,   328,   234,   235,
     236,   227,   330,   229,   137,     1,    21,   135,   136,    93,
     137,   202,   338,     1,    21,    69,    70,   206,   352,     1,
      21,   322,    55,   280,   162,   282,   346,    73,    56,     1,
      21,   163,     1,    57,   224,   222,   223,   254,   167,   221,
     304,    95,   283,   260,     1,    21,   130,    90,   249,    58,
      91,    91,    74,    75,   300,    76,    79,   250,   224,   224,
     223,   223,   150,   306,   152,   271,    67,   305,   253,    80,
      81,    59,    95,    82,   307,   159,    60,   315,    83,   281,
      96,    61,   256,   131,    62,   344,    63,    97,   389,    64,
     265,   267,   308,   302,    21,    77,    91,   329,   309,    91,
     268,   269,   270,    78,   192,   274,   191,   224,   222,   223,
     420,   133,   301,    84,   125,   128,   397,   160,    97,   161,
     343,   246,   192,   190,   191,   383,   325,    91,    91,    92,
     428,   413,    86,   324,    93,   238,   239,   421,   220,     1,
      21,   134,   414,   335,   137,   337,   423,   339,    91,   435,
     211,   212,   213,   135,   136,    93,   137,    91,   114,   345,
      91,   347,   117,     7,   119,     8,     9,   310,   120,     1,
      21,     1,    21,   390,   137,   224,   224,   223,   223,   224,
     327,   223,    69,   122,    10,   369,   123,   125,   158,    11,
      12,    13,    14,    15,    16,   128,   192,   274,   191,   151,
      17,    18,   334,    19,   238,   239,   388,   221,     1,    21,
     318,   319,    95,   137,   194,   198,   425,   201,   159,   173,
     174,   204,   209,   137,   419,   404,   210,   215,   434,     5,
     230,   248,   251,   257,   160,   277,   278,    20,     1,    21,
     284,   376,   175,   367,  -224,     5,   285,   289,   292,   381,
     377,   378,   290,   382,   176,   177,   178,   179,   180,   181,
     182,   183,   385,   184,   384,   294,   185,   186,   187,   188,
     293,   299,   317,   408,   311,   224,   405,   223,   320,   323,
     412,   348,   409,   106,   107,   108,   109,   110,   111,   112,
     113,   332,   341,   360,   356,   371,   368,   372,   373,   374,
     386,   392,   398,   415,     1,    21,   416,   406,   380,   393,
     417,   429,   433,   399,   431,     4,   387,    65,   276,   172,
     326,   121,   232,   140,   252,   427,   237,   336,   366,   379,
     426,   410,   424,   370,   432,   402,   403,   156,     0,    89,
     331,   193,     0,     0,   233
};

static const yytype_int16 yycheck[] =
{
       9,     0,     3,     3,     3,    22,    78,   145,    86,    78,
      79,   170,     9,    15,     8,    74,    67,   247,   205,    10,
      10,    22,    22,    22,     9,    20,    14,    78,    10,    35,
     289,    20,   378,   226,    10,    77,    16,    76,    87,    88,
       8,     9,    81,    10,    91,    46,     8,    96,    13,    91,
      64,    12,   134,   125,   123,   149,     8,     9,   317,    21,
      40,    51,     9,   409,   146,    14,   117,    97,   119,    83,
       0,     8,     9,    20,    97,    14,   145,    68,    84,    74,
     218,    97,     9,    68,    86,    52,    75,   280,   157,   282,
      51,    90,   322,    20,    91,    92,    95,    91,    92,    96,
     151,    89,   103,   103,   103,   199,    96,   300,   159,   160,
     161,   150,   305,   152,    96,    91,    92,    93,    94,    95,
      96,   122,   315,    91,    92,    38,    39,   128,    77,    91,
      92,   290,    14,   227,   164,   229,   329,     4,    14,    91,
      92,   164,    91,    14,   145,   145,   145,   198,   164,   218,
       9,    12,   230,   204,    91,    92,    33,    17,    41,    14,
      20,    20,    29,    30,   258,    32,    14,    50,   169,   170,
     169,   170,    82,     9,    84,   214,    26,   271,   195,    27,
      28,    14,    12,    31,    20,    23,    14,   281,    36,   228,
      51,    14,   201,    70,    14,     9,    14,    58,     9,    14,
     209,   210,   274,   262,    92,    72,    20,   301,   277,    20,
     211,   212,   213,    14,   215,   215,   215,   218,   218,   218,
     407,    51,   261,    71,    62,    63,     9,    65,    58,    67,
     324,    73,   233,   233,   233,   373,   295,    20,    20,    21,
     427,     9,    14,   294,    95,    87,    88,     9,   386,    91,
      92,    81,    20,   312,    96,   314,     9,   316,    20,     9,
      59,    60,    61,    93,    94,    95,    96,    20,    15,   328,
      20,   330,    24,    16,    14,    18,    19,   278,    14,    91,
      92,    91,    92,   377,    96,   286,   287,   286,   287,   290,
     299,   290,    38,     3,    37,   354,    14,    62,    52,    42,
      43,    44,    45,    46,    47,    63,   307,   307,   307,    80,
      53,    54,   311,    56,    87,    88,   375,   386,    91,    92,
     286,   287,    12,    96,    40,    25,   420,    10,    23,     6,
       7,    82,    10,    96,   406,   386,    10,    10,   432,   338,
      85,    50,    49,     5,    65,    68,    22,    90,    91,    92,
      11,   360,    29,   352,    68,   354,    22,    68,    49,   368,
     361,   362,    68,   372,    41,    42,    43,    44,    45,    46,
      47,    48,   373,    50,   373,    57,    53,    54,    55,    56,
      49,    10,    22,   392,    89,   386,   386,   386,     9,    69,
     399,    34,   393,    56,    57,    58,    59,    60,    61,    62,
      63,    69,    69,    10,    69,    69,    78,    10,    10,    66,
      10,    10,     9,     9,    91,    92,     9,    76,    78,    75,
       9,    79,   431,    10,    10,     0,   374,    22,   218,   100,
     296,    72,   158,    78,   195,   422,   164,   312,   350,   364,
     421,   395,   414,   354,   430,   386,   386,    91,    -1,    47,
     307,   104,    -1,    -1,   158
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    91,    98,   101,   102,   197,     0,    16,    18,    19,
      37,    42,    43,    44,    45,    46,    47,    53,    54,    56,
      90,    92,    99,   100,   103,   112,   113,   114,   115,   116,
     120,   129,   130,   138,   142,   144,   150,   160,   161,   162,
     171,   196,   197,   198,   199,    13,     8,   184,   185,   186,
     187,   197,   198,   186,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,   100,   199,    26,   123,    38,
      39,   131,   132,     4,    29,    30,    32,    72,    14,    14,
      27,    28,    31,    36,    71,   104,    14,   198,    21,   185,
      17,    20,    21,    95,   183,    12,    51,    58,   139,   140,
     141,   143,   147,   191,   192,   193,   143,   143,   143,   143,
     143,   143,   143,   143,    15,   200,   183,    24,   121,    14,
      14,   131,     3,    14,   104,    62,   133,   134,    63,   173,
      33,    70,   159,    51,    81,    93,    94,    96,   111,   139,
     147,   181,   182,   183,   195,    10,    51,   105,   111,   173,
     159,    80,   159,    86,   200,   197,   187,   197,    52,    23,
      65,    67,   125,   134,   148,   149,   173,   175,   176,    10,
      68,   126,   126,     6,     7,    29,    41,    42,    43,    44,
      45,    46,    47,    48,    50,    53,    54,    55,    56,   194,
     196,   197,   198,   193,    40,   145,   146,   183,    25,   122,
     183,    10,   198,   139,    82,   135,   198,   124,   125,    10,
      10,    59,    60,    61,   172,    10,   190,   190,   106,   107,
     110,   111,   196,   197,   198,   190,   124,   173,   183,   173,
      85,   111,   140,   191,   183,   183,   183,   149,    87,    88,
     108,   109,   110,   111,   127,   196,    73,   127,    50,    41,
      50,    49,   146,   199,   183,   124,   186,     5,   151,   152,
     183,   172,   174,   175,     9,   186,     9,   186,   198,   198,
     198,   173,   188,   189,   196,     9,   107,    68,    22,   174,
     124,   173,   124,   200,    11,    22,    20,    74,   128,    68,
      68,   128,    49,    49,    57,   117,   118,   119,     9,    10,
     124,   173,   104,     9,     9,   124,     9,    20,   139,   111,
     198,    89,   163,   164,   174,   124,   174,    22,   108,   108,
       9,   109,   127,    69,   183,   104,   119,   186,   174,   124,
     174,   188,    69,   165,   197,   104,   164,   104,   174,   104,
     109,    69,   128,   124,     9,   104,   174,   104,    34,   153,
     154,   155,    77,   102,   169,   170,    69,    64,    83,   177,
      10,    35,    84,   156,   157,   158,   155,   197,    78,   104,
     170,    69,    10,    10,    66,   178,   186,   198,   198,   158,
      78,   186,   186,   110,   197,   198,    10,   105,   104,     9,
     124,   133,    10,    75,   166,   167,   168,     9,     9,    10,
     179,   180,   181,   182,   183,   196,    76,   136,   186,   198,
     168,     9,   186,     9,    20,     9,     9,     9,     9,   139,
     172,     9,   133,     9,   180,   124,   166,   136,   172,    79,
     137,    10,   178,   186,   124,     9
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    97,    98,    98,    99,    99,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     101,   102,   102,   103,   103,   104,   104,   105,   106,   106,
     107,   107,   107,   108,   108,   108,   108,   109,   109,   109,
     110,   110,   111,   112,   113,   114,   115,   116,   117,   117,
     118,   118,   119,   120,   121,   122,   123,   124,   124,   125,
     126,   126,   126,   127,   127,   127,   128,   128,   129,   129,
     129,   130,   131,   132,   133,   133,   134,   135,   135,   136,
     136,   137,   137,   138,   138,   138,   138,   138,   138,   138,
     139,   139,   139,   139,   140,   141,   141,   141,   141,   141,
     141,   141,   141,   141,   141,   141,   141,   142,   142,   142,
     142,   142,   142,   142,   142,   142,   143,   143,   144,   145,
     145,   146,   147,   148,   148,   149,   149,   149,   149,   149,
     150,   150,   151,   151,   152,   153,   153,   154,   154,   155,
     156,   156,   157,   157,   158,   158,   159,   159,   159,   159,
     159,   160,   161,   162,   163,   163,   164,   165,   165,   166,
     166,   167,   167,   168,   169,   169,   170,   170,   171,   172,
     172,   172,   172,   173,   174,   174,   175,   176,   177,   177,
     177,   178,   178,   178,   178,   178,   178,   178,   179,   179,
     180,   180,   181,   182,   183,   184,   184,   185,   186,   186,
     187,   187,   187,   188,   189,   189,   190,   191,   191,   192,
     192,   193,   194,   194,   194,   194,   194,   194,   194,   195,
     195,   195,   195,   196,   196,   197,   198,   199,   200
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     4,     6,     3,     2,     2,     2,     3,     2,     1,
       1,     1,     4,     1,     1,     4,     4,     1,     1,     1,
       3,     1,     1,     6,    11,     7,     3,     3,     1,     0,
       2,     1,     3,     2,     2,     2,     2,     1,     0,     2,
       4,     7,     4,     3,     3,     1,     1,     0,     1,     2,
       3,     3,     3,     5,     1,     0,     2,     2,     0,     2,
       0,     4,     0,     1,     3,     3,     4,     4,     4,     3,
       1,     1,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     3,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     5,     2,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       8,     8,     1,     0,     4,     1,     0,     2,     1,     4,
       1,     0,     2,     1,     6,     3,     4,     3,     4,     3,
       0,     7,     7,     7,     2,     1,     4,     1,     0,     1,
       0,     2,     1,     8,     2,     1,     7,     4,     9,     2,
       2,     2,     0,     2,     1,     0,     2,     2,     4,     4,
       0,     4,     4,     4,     4,     4,     2,     0,     3,     1,
       3,     2,     1,     1,     1,     2,     1,     3,     3,     1,
       1,     1,     2,     2,     1,     3,     3,     1,     0,     2,
       1,     4,     2,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_MACRO_SYM: /* MACRO_SYM  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1492 "parser.tab.cpp"
        break;

    case YYSYMBOL_UCASEFIRST_IDENT_SYM: /* UCASEFIRST_IDENT_SYM  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1498 "parser.tab.cpp"
        break;

    case YYSYMBOL_LCASEFIRST_IDENT_SYM: /* LCASEFIRST_IDENT_SYM  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1504 "parser.tab.cpp"
        break;

    case YYSYMBOL_BSTRING_SYM: /* BSTRING_SYM  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1510 "parser.tab.cpp"
        break;

    case YYSYMBOL_HSTRING_SYM: /* HSTRING_SYM  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1516 "parser.tab.cpp"
        break;

    case YYSYMBOL_CSTRING_SYM: /* CSTRING_SYM  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1522 "parser.tab.cpp"
        break;

    case YYSYMBOL_ModuleIdentifier: /* ModuleIdentifier  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1528 "parser.tab.cpp"
        break;

    case YYSYMBOL_ObjectIdentifierAssignment: /* ObjectIdentifierAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1534 "parser.tab.cpp"
        break;

    case YYSYMBOL_AssignedIdentifier: /* AssignedIdentifier  */
#line 248 "parser.y"
            { delete ((*yyvaluep).oid); }
#line 1540 "parser.tab.cpp"
        break;

    case YYSYMBOL_AssignedIdentifierList: /* AssignedIdentifierList  */
#line 248 "parser.y"
            { delete ((*yyvaluep).oid); }
#line 1546 "parser.tab.cpp"
        break;

    case YYSYMBOL_ObjectIdentifierList: /* ObjectIdentifierList  */
#line 248 "parser.y"
            { delete ((*yyvaluep).oid); }
#line 1552 "parser.tab.cpp"
        break;

    case YYSYMBOL_ObjectIdentifier: /* ObjectIdentifier  */
#line 252 "parser.y"
            { delete ((*yyvaluep).pSubId); }
#line 1558 "parser.tab.cpp"
        break;

    case YYSYMBOL_DefinedValue: /* DefinedValue  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1564 "parser.tab.cpp"
        break;

    case YYSYMBOL_ObjectIdentityAssignment: /* ObjectIdentityAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1570 "parser.tab.cpp"
        break;

    case YYSYMBOL_ObjectTypeAssignment: /* ObjectTypeAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1576 "parser.tab.cpp"
        break;

    case YYSYMBOL_ModuleIdentityAssignment: /* ModuleIdentityAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1582 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpIdentityPart: /* SnmpIdentityPart  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1588 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpDescriptionPart: /* SnmpDescriptionPart  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1594 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpDescriptionStatement: /* SnmpDescriptionStatement  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1600 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpSyntaxPart: /* SnmpSyntaxPart  */
#line 253 "parser.y"
            { delete ((*yyvaluep).pSyntax); }
#line 1606 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpSyntaxStatement: /* SnmpSyntaxStatement  */
#line 253 "parser.y"
            { delete ((*yyvaluep).pSyntax); }
#line 1612 "parser.tab.cpp"
        break;

    case YYSYMBOL_TypeOrValueAssignment: /* TypeOrValueAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1618 "parser.tab.cpp"
        break;

    case YYSYMBOL_Type: /* Type  */
#line 253 "parser.y"
            { delete ((*yyvaluep).pSyntax); }
#line 1624 "parser.tab.cpp"
        break;

    case YYSYMBOL_NamedType: /* NamedType  */
#line 253 "parser.y"
            { delete ((*yyvaluep).pSyntax); }
#line 1630 "parser.tab.cpp"
        break;

    case YYSYMBOL_BuiltInType: /* BuiltInType  */
#line 253 "parser.y"
            { delete ((*yyvaluep).pSyntax); }
#line 1636 "parser.tab.cpp"
        break;

    case YYSYMBOL_BuiltInTypeAssignment: /* BuiltInTypeAssignment  */
#line 253 "parser.y"
            { delete ((*yyvaluep).pSyntax); }
#line 1642 "parser.tab.cpp"
        break;

    case YYSYMBOL_MacroAssignment: /* MacroAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1648 "parser.tab.cpp"
        break;

    case YYSYMBOL_TextualConventionAssignment: /* TextualConventionAssignment  */
#line 253 "parser.y"
            { delete ((*yyvaluep).pSyntax); }
#line 1654 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpNotificationTypeAssignment: /* SnmpNotificationTypeAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1660 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpObjectGroupAssignment: /* SnmpObjectGroupAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1666 "parser.tab.cpp"
        break;

    case YYSYMBOL_SnmpNotificationGroupAssignment: /* SnmpNotificationGroupAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1672 "parser.tab.cpp"
        break;

    case YYSYMBOL_AgentCapabilitiesAssignment: /* AgentCapabilitiesAssignment  */
#line 251 "parser.y"
            { delete ((*yyvaluep).pObject); }
#line 1678 "parser.tab.cpp"
        break;

    case YYSYMBOL_CharString: /* CharString  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1684 "parser.tab.cpp"
        break;

    case YYSYMBOL_SymbolsFromModuleList: /* SymbolsFromModuleList  */
#line 249 "parser.y"
            { delete ((*yyvaluep).pImportList); }
#line 1690 "parser.tab.cpp"
        break;

    case YYSYMBOL_SymbolsFromModule: /* SymbolsFromModule  */
#line 250 "parser.y"
            { delete ((*yyvaluep).pImports); }
#line 1696 "parser.tab.cpp"
        break;

    case YYSYMBOL_Symbol: /* Symbol  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1702 "parser.tab.cpp"
        break;

    case YYSYMBOL_Identifier: /* Identifier  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1708 "parser.tab.cpp"
        break;

    case YYSYMBOL_UCidentifier: /* UCidentifier  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1714 "parser.tab.cpp"
        break;

    case YYSYMBOL_LCidentifier: /* LCidentifier  */
#line 247 "parser.y"
            { MemFree(((*yyvaluep).pszString)); }
#line 1720 "parser.tab.cpp"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* Assignment: ObjectIdentifierAssignment  */
#line 278 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1990 "parser.tab.cpp"
    break;

  case 7: /* Assignment: ObjectIdentityAssignment  */
#line 282 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 1998 "parser.tab.cpp"
    break;

  case 8: /* Assignment: ObjectTypeAssignment  */
#line 286 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2006 "parser.tab.cpp"
    break;

  case 9: /* Assignment: MacroAssignment  */
#line 290 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2014 "parser.tab.cpp"
    break;

  case 10: /* Assignment: TypeOrValueAssignment  */
#line 294 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2022 "parser.tab.cpp"
    break;

  case 11: /* Assignment: SnmpNotificationTypeAssignment  */
#line 298 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2030 "parser.tab.cpp"
    break;

  case 13: /* Assignment: SnmpNotificationGroupAssignment  */
#line 303 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2038 "parser.tab.cpp"
    break;

  case 14: /* Assignment: SnmpObjectGroupAssignment  */
#line 307 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2046 "parser.tab.cpp"
    break;

  case 16: /* Assignment: AgentCapabilitiesAssignment  */
#line 312 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2054 "parser.tab.cpp"
    break;

  case 17: /* Assignment: ModuleIdentityAssignment  */
#line 316 "parser.y"
{
   m_pModule->pObjectList->add((yyvsp[0].pObject));
}
#line 2062 "parser.tab.cpp"
    break;

  case 20: /* ModuleIdentifierAssignment: ModuleIdentifier  */
#line 325 "parser.y"
{
   m_pModule = new MP_MODULE;
   m_pModule->pszName = (yyvsp[0].pszString);
}
#line 2071 "parser.tab.cpp"
    break;

  case 21: /* ModuleIdentifier: UCidentifier DEFINITIONS_SYM ASSIGNMENT_SYM Begin  */
#line 333 "parser.y"
{
   (yyval.pszString) = (yyvsp[-3].pszString);
}
#line 2079 "parser.tab.cpp"
    break;

  case 22: /* ModuleIdentifier: UCidentifier DEFINITIONS_SYM ASSIGNMENT_SYM AUTOMATIC_SYM TAGS_SYM Begin  */
#line 337 "parser.y"
{
   (yyval.pszString) = (yyvsp[-5].pszString);
}
#line 2087 "parser.tab.cpp"
    break;

  case 23: /* ObjectIdentifierAssignment: Identifier OBJECT_IDENTIFIER_SYM AssignedIdentifier  */
#line 344 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      ReportError(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2102 "parser.tab.cpp"
    break;

  case 24: /* ObjectIdentifierAssignment: LCidentifier AssignedIdentifier  */
#line 355 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-1].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
}
#line 2113 "parser.tab.cpp"
    break;

  case 25: /* AssignedIdentifier: ASSIGNMENT_SYM AssignedIdentifierList  */
#line 365 "parser.y"
{
   (yyval.oid) = (yyvsp[0].oid);
}
#line 2121 "parser.tab.cpp"
    break;

  case 26: /* AssignedIdentifier: ASSIGNMENT_SYM Number  */
#line 369 "parser.y"
{
   MP_SUBID *subid;

   subid = new MP_SUBID;
   subid->dwValue = (yyvsp[0].number).value.nInt32;
   subid->pszName = NULL;
   subid->bResolved = TRUE;
   (yyval.oid) = new ObjectArray<MP_SUBID>(16, 16, Ownership::True);
   (yyval.oid)->add(subid);
}
#line 2136 "parser.tab.cpp"
    break;

  case 27: /* AssignedIdentifierList: LEFT_BRACE_SYM ObjectIdentifierList RIGHT_BRACE_SYM  */
#line 383 "parser.y"
{
   (yyval.oid) = (yyvsp[-1].oid);
}
#line 2144 "parser.tab.cpp"
    break;

  case 28: /* ObjectIdentifierList: ObjectIdentifierList ObjectIdentifier  */
#line 390 "parser.y"
{
	(yyval.oid) = (yyvsp[-1].oid);
   (yyval.oid)->add((yyvsp[0].pSubId));
   (yyvsp[0].pSubId) = nullptr;
}
#line 2154 "parser.tab.cpp"
    break;

  case 29: /* ObjectIdentifierList: ObjectIdentifier  */
#line 396 "parser.y"
{
   (yyval.oid) = new ObjectArray<MP_SUBID>(16, 16, Ownership::True);
   (yyval.oid)->add((yyvsp[0].pSubId));
   (yyvsp[0].pSubId) = nullptr;
}
#line 2164 "parser.tab.cpp"
    break;

  case 30: /* ObjectIdentifier: Number  */
#line 405 "parser.y"
{
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = (yyvsp[0].number).value.nInt32;
   (yyval.pSubId)->pszName = nullptr;
   (yyval.pSubId)->bResolved = TRUE;
}
#line 2175 "parser.tab.cpp"
    break;

  case 31: /* ObjectIdentifier: DefinedValue  */
#line 412 "parser.y"
{
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = 0;
   (yyval.pSubId)->pszName = (yyvsp[0].pszString);
   (yyval.pSubId)->bResolved = FALSE;
   (yyvsp[0].pszString) = nullptr;
}
#line 2187 "parser.tab.cpp"
    break;

  case 32: /* ObjectIdentifier: Identifier LEFT_PAREN_SYM Number RIGHT_PAREN_SYM  */
#line 420 "parser.y"
{
   (yyval.pSubId) = new MP_SUBID;
   (yyval.pSubId)->dwValue = (yyvsp[-1].number).value.nInt32;
   (yyval.pSubId)->pszName = (yyvsp[-3].pszString);
   (yyval.pSubId)->bResolved = TRUE;
   (yyvsp[-3].pszString) = nullptr;
}
#line 2199 "parser.tab.cpp"
    break;

  case 34: /* NumericValue: DefinedValue  */
#line 432 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2207 "parser.tab.cpp"
    break;

  case 36: /* NumericValue: Identifier LEFT_PAREN_SYM NumberOrMinMax RIGHT_PAREN_SYM  */
#line 437 "parser.y"
{
   MemFreeAndNull((yyvsp[-3].pszString));
}
#line 2215 "parser.tab.cpp"
    break;

  case 40: /* DefinedValue: UCidentifier DOT_SYM LCidentifier  */
#line 450 "parser.y"
{
   (yyval.pszString) = MemAllocStringA(strlen((yyvsp[-2].pszString)) + strlen((yyvsp[0].pszString)) + 2);
   sprintf((yyval.pszString), "%s.%s", (yyvsp[-2].pszString), (yyvsp[0].pszString));
   MemFreeAndNull((yyvsp[-2].pszString));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2226 "parser.tab.cpp"
    break;

  case 41: /* DefinedValue: LCidentifier  */
#line 457 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2234 "parser.tab.cpp"
    break;

  case 42: /* Number: NUMBER_SYM  */
#line 464 "parser.y"
{
   (yyval.number) = (yyvsp[0].number);
}
#line 2242 "parser.tab.cpp"
    break;

  case 43: /* ObjectIdentityAssignment: Identifier OBJECT_IDENTITY_SYM SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 475 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-5].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      ReportError(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2259 "parser.tab.cpp"
    break;

  case 44: /* ObjectTypeAssignment: Identifier OBJECT_TYPE_SYM SnmpSyntaxPart SnmpUnitsPart SnmpAccessPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart SnmpIndexPart SnmpDefValPart AssignedIdentifier  */
#line 500 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-10].pszString);
   (yyval.pObject)->iSyntax = (yyvsp[-8].pSyntax)->nSyntax;
   (yyval.pObject)->pszDataType = (yyvsp[-8].pSyntax)->pszStr;
   (yyvsp[-8].pSyntax)->pszStr = nullptr;
   delete (yyvsp[-8].pSyntax);
   (yyval.pObject)->iAccess = (yyvsp[-6].nInteger);
   (yyval.pObject)->iStatus = (yyvsp[-5].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-4].pszString);
   (yyval.pObject)->index = (yyvsp[-2].stringList);
   (yyval.pObject)->oid = (yyvsp[0].oid);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      ReportError(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2282 "parser.tab.cpp"
    break;

  case 45: /* ModuleIdentityAssignment: SnmpIdentityPart SnmpUpdatePart SnmpOrganisationPart SnmpContactInfoPart SnmpDescriptionPart SnmpRevisionPart AssignedIdentifier  */
#line 528 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->iSyntax = MIB_TYPE_MODID;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
}
#line 2295 "parser.tab.cpp"
    break;

  case 46: /* ImportsAssignment: IMPORTS_SYM SymbolsFromModuleList SEMI_COLON_SYM  */
#line 540 "parser.y"
{
	delete m_pModule->pImportList;
   m_pModule->pImportList = (yyvsp[-1].pImportList);
}
#line 2304 "parser.tab.cpp"
    break;

  case 47: /* ExportsAssignment: EXPORTS_SYM SymbolList SEMI_COLON_SYM  */
#line 548 "parser.y"
{
   delete (yyvsp[-1].stringList);
}
#line 2312 "parser.tab.cpp"
    break;

  case 52: /* SnmpRevisionObject: REVISION_SYM CharString SnmpDescriptionPart  */
#line 566 "parser.y"
{
   MemFreeAndNull((yyvsp[-1].pszString));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2321 "parser.tab.cpp"
    break;

  case 53: /* SnmpIdentityPart: LCidentifier MODULE_IDENTITY_SYM  */
#line 574 "parser.y"
{
   (yyval.pszString) = (yyvsp[-1].pszString);
}
#line 2329 "parser.tab.cpp"
    break;

  case 54: /* SnmpOrganisationPart: ORGANIZATION_SYM CharString  */
#line 581 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2337 "parser.tab.cpp"
    break;

  case 55: /* SnmpContactInfoPart: CONTACT_SYM CharString  */
#line 588 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2345 "parser.tab.cpp"
    break;

  case 56: /* SnmpUpdatePart: UPDATE_SYM CharString  */
#line 595 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2353 "parser.tab.cpp"
    break;

  case 57: /* SnmpDescriptionPart: SnmpDescriptionStatement  */
#line 602 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2361 "parser.tab.cpp"
    break;

  case 58: /* SnmpDescriptionPart: %empty  */
#line 606 "parser.y"
{
   (yyval.pszString) = nullptr;
}
#line 2369 "parser.tab.cpp"
    break;

  case 59: /* SnmpDescriptionStatement: DESCRIPTION_SYM CharString  */
#line 613 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 2377 "parser.tab.cpp"
    break;

  case 66: /* DanglingComma: COMMA_SYM  */
#line 632 "parser.y"
{
   ReportError(ERR_DANGLING_COMMA, s_currentFilename, g_nCurrLine);
}
#line 2385 "parser.tab.cpp"
    break;

  case 71: /* SnmpKeywordName: KEYWORD_SYM ASSIGNMENT_SYM CharString  */
#line 646 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2393 "parser.tab.cpp"
    break;

  case 72: /* SnmpKeywordValue: KEYWORD_VALUE_SYM ASSIGNMENT_SYM CharString  */
#line 653 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2401 "parser.tab.cpp"
    break;

  case 73: /* SnmpKeywordBinding: KEYWORD_BIND_SYM ASSIGNMENT_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 660 "parser.y"
{
   delete_and_null((yyvsp[-1].stringList));
}
#line 2409 "parser.tab.cpp"
    break;

  case 74: /* SnmpSyntaxPart: SnmpSyntaxStatement  */
#line 667 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2417 "parser.tab.cpp"
    break;

  case 75: /* SnmpSyntaxPart: %empty  */
#line 671 "parser.y"
{
   (yyval.pSyntax) = new MP_SYNTAX;
   (yyval.pSyntax)->nSyntax = MIB_TYPE_OTHER;
}
#line 2426 "parser.tab.cpp"
    break;

  case 76: /* SnmpSyntaxStatement: SYNTAX_SYM Type  */
#line 679 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2434 "parser.tab.cpp"
    break;

  case 77: /* SnmpUnitsPart: UNITS_SYM CharString  */
#line 686 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2442 "parser.tab.cpp"
    break;

  case 79: /* SnmpWriteSyntaxPart: WRITE_SYNTAX_SYM Type  */
#line 694 "parser.y"
{
	delete_and_null((yyvsp[0].pSyntax));
}
#line 2450 "parser.tab.cpp"
    break;

  case 81: /* SnmpCreationPart: CREATION_REQUIRES_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 702 "parser.y"
{
   delete_and_null((yyvsp[-1].stringList));
}
#line 2458 "parser.tab.cpp"
    break;

  case 83: /* TypeOrValueAssignment: BuiltInTypeAssignment  */
#line 710 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TYPEDEF;
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
   if ((yyvsp[0].pSyntax) != nullptr)
   {
      (yyval.pObject)->pszName = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = nullptr;
      (yyvsp[0].pSyntax)->pszDescription = nullptr;
      delete_and_null((yyvsp[0].pSyntax));
   }
}
#line 2477 "parser.tab.cpp"
    break;

  case 84: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM TextualConventionAssignment  */
#line 725 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TEXTUAL_CONVENTION;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
   if ((yyvsp[0].pSyntax) != nullptr)
   {
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDataType = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = nullptr;
      (yyvsp[0].pSyntax)->pszDescription = nullptr;
      delete_and_null((yyvsp[0].pSyntax));
   }
}
#line 2497 "parser.tab.cpp"
    break;

  case 85: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM Type  */
#line 741 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_TYPEDEF;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
   if ((yyvsp[0].pSyntax) != nullptr)
   {
      (yyval.pObject)->iSyntax = (yyvsp[0].pSyntax)->nSyntax;
      (yyval.pObject)->pszDataType = (yyvsp[0].pSyntax)->pszStr;
      (yyval.pObject)->pszDescription = (yyvsp[0].pSyntax)->pszDescription;
      (yyvsp[0].pSyntax)->pszStr = nullptr;
      (yyvsp[0].pSyntax)->pszDescription = nullptr;
      delete_and_null((yyvsp[0].pSyntax));
   }
}
#line 2517 "parser.tab.cpp"
    break;

  case 86: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM SEQUENCE_SYM SequenceAssignment  */
#line 757 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_SEQUENCE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
}
#line 2528 "parser.tab.cpp"
    break;

  case 87: /* TypeOrValueAssignment: LCidentifier ASSIGNMENT_SYM SEQUENCE_SYM SequenceAssignment  */
#line 764 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_SEQUENCE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
}
#line 2539 "parser.tab.cpp"
    break;

  case 88: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM CHOICE_SYM SequenceAssignment  */
#line 771 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_CHOICE;
   (yyval.pObject)->pszName = (yyvsp[-3].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
}
#line 2550 "parser.tab.cpp"
    break;

  case 89: /* TypeOrValueAssignment: UCidentifier ASSIGNMENT_SYM Value  */
#line 778 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_VALUE;
   (yyval.pObject)->pszName = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
}
#line 2561 "parser.tab.cpp"
    break;

  case 90: /* Type: BuiltInType  */
#line 788 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2569 "parser.tab.cpp"
    break;

  case 91: /* Type: NamedType  */
#line 792 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[0].pSyntax);
}
#line 2577 "parser.tab.cpp"
    break;

  case 92: /* Type: BuiltInType ValueConstraint  */
#line 796 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[-1].pSyntax);
}
#line 2585 "parser.tab.cpp"
    break;

  case 93: /* Type: NamedType ValueConstraint  */
#line 800 "parser.y"
{
   (yyval.pSyntax) = (yyvsp[-1].pSyntax);
}
#line 2593 "parser.tab.cpp"
    break;

  case 94: /* NamedType: SnmpTypeTagPart Identifier  */
#line 807 "parser.y"
{
   (yyval.pSyntax) = new MP_SYNTAX;
   (yyval.pSyntax)->nSyntax = -1;
   (yyval.pSyntax)->pszStr = (yyvsp[0].pszString);
}
#line 2603 "parser.tab.cpp"
    break;

  case 95: /* BuiltInType: SnmpTypeTagPart INTEGER_SYM  */
#line 816 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER);
}
#line 2611 "parser.tab.cpp"
    break;

  case 96: /* BuiltInType: SnmpTypeTagPart IMPLICIT_SYM INTEGER_SYM  */
#line 820 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER);
}
#line 2619 "parser.tab.cpp"
    break;

  case 97: /* BuiltInType: SnmpTypeTagPart INTEGER32_SYM  */
#line 824 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER32);
}
#line 2627 "parser.tab.cpp"
    break;

  case 98: /* BuiltInType: SnmpTypeTagPart UNSIGNED32_SYM  */
#line 828 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_UNSIGNED32);
}
#line 2635 "parser.tab.cpp"
    break;

  case 99: /* BuiltInType: SnmpTypeTagPart COUNTER_SYM  */
#line 832 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER);
}
#line 2643 "parser.tab.cpp"
    break;

  case 100: /* BuiltInType: SnmpTypeTagPart COUNTER32_SYM  */
#line 836 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER32);
}
#line 2651 "parser.tab.cpp"
    break;

  case 101: /* BuiltInType: SnmpTypeTagPart COUNTER64_SYM  */
#line 840 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER64);
}
#line 2659 "parser.tab.cpp"
    break;

  case 102: /* BuiltInType: SnmpTypeTagPart GAUGE32_SYM  */
#line 844 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_GAUGE32);
}
#line 2667 "parser.tab.cpp"
    break;

  case 103: /* BuiltInType: SnmpTypeTagPart TIMETICKS_SYM  */
#line 848 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_TIMETICKS);
}
#line 2675 "parser.tab.cpp"
    break;

  case 104: /* BuiltInType: SEQUENCE_SYM OF_SYM NamedType  */
#line 852 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_SEQUENCE);
   delete (yyvsp[0].pSyntax);
}
#line 2684 "parser.tab.cpp"
    break;

  case 105: /* BuiltInType: SnmpTypeTagPart OBJECT_IDENTIFIER_SYM  */
#line 857 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OBJID);
}
#line 2692 "parser.tab.cpp"
    break;

  case 106: /* BuiltInType: SnmpTypeTagPart OctetStringType  */
#line 861 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OCTETSTR);
}
#line 2700 "parser.tab.cpp"
    break;

  case 107: /* BuiltInTypeAssignment: IP_ADDRESS_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 868 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_IPADDR);
   (yyval.pSyntax)->pszStr = MemCopyStringA("IpAddress");
}
#line 2709 "parser.tab.cpp"
    break;

  case 108: /* BuiltInTypeAssignment: OPAQUE_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 873 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_OPAQUE);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Opaque");
}
#line 2718 "parser.tab.cpp"
    break;

  case 109: /* BuiltInTypeAssignment: INTEGER32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 878 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_INTEGER32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Integer32");
}
#line 2727 "parser.tab.cpp"
    break;

  case 110: /* BuiltInTypeAssignment: UNSIGNED32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 883 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_UNSIGNED32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Unsigned32");
}
#line 2736 "parser.tab.cpp"
    break;

  case 111: /* BuiltInTypeAssignment: TIMETICKS_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 888 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_TIMETICKS);
   (yyval.pSyntax)->pszStr = MemCopyStringA("TimeTicks");
}
#line 2745 "parser.tab.cpp"
    break;

  case 112: /* BuiltInTypeAssignment: COUNTER_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 893 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter");
}
#line 2754 "parser.tab.cpp"
    break;

  case 113: /* BuiltInTypeAssignment: COUNTER32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 898 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter32");
}
#line 2763 "parser.tab.cpp"
    break;

  case 114: /* BuiltInTypeAssignment: COUNTER64_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 903 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_COUNTER64);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Counter64");
}
#line 2772 "parser.tab.cpp"
    break;

  case 115: /* BuiltInTypeAssignment: GAUGE32_SYM ASSIGNMENT_SYM TypeOrTextualConvention  */
#line 908 "parser.y"
{
   (yyval.pSyntax) = create_std_syntax(MIB_TYPE_GAUGE32);
   (yyval.pSyntax)->pszStr = MemCopyStringA("Gauge32");
}
#line 2781 "parser.tab.cpp"
    break;

  case 116: /* TypeOrTextualConvention: Type  */
#line 916 "parser.y"
{
   delete (yyvsp[0].pSyntax);
}
#line 2789 "parser.tab.cpp"
    break;

  case 117: /* TypeOrTextualConvention: TextualConventionAssignment  */
#line 920 "parser.y"
{
   delete (yyvsp[0].pSyntax);
}
#line 2797 "parser.tab.cpp"
    break;

  case 118: /* MacroAssignment: MACRO_SYM ASSIGNMENT_SYM Begin TokenList End  */
#line 927 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_MACRO;
   (yyval.pObject)->pszName = (yyvsp[-4].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(0, 16, Ownership::True);
}
#line 2808 "parser.tab.cpp"
    break;

  case 122: /* TextualConventionAssignment: TEXTUAL_CONVENTION_SYM TextualConventionDefinition  */
#line 946 "parser.y"
{
   (yyval.pSyntax) = s_currentSyntaxObject;
   s_currentSyntaxObject = nullptr;
}
#line 2817 "parser.tab.cpp"
    break;

  case 127: /* TextualConventionDefinitionElement: SnmpDescriptionStatement  */
#line 961 "parser.y"
{
	if (s_currentSyntaxObject != nullptr)
	{
		MemFree(s_currentSyntaxObject->pszDescription);
	}
	else
	{
		s_currentSyntaxObject = new MP_SYNTAX();
	}
	s_currentSyntaxObject->pszDescription = (yyvsp[0].pszString);
}
#line 2833 "parser.tab.cpp"
    break;

  case 129: /* TextualConventionDefinitionElement: SnmpSyntaxStatement  */
#line 974 "parser.y"
{
	if (s_currentSyntaxObject != nullptr)
	{
		s_currentSyntaxObject->nSyntax = (yyvsp[0].pSyntax)->nSyntax;
		MemFree(s_currentSyntaxObject->pszStr);
		s_currentSyntaxObject->pszStr = (yyvsp[0].pSyntax)->pszStr;
		(yyvsp[0].pSyntax)->pszStr = nullptr;
		delete_and_null((yyvsp[0].pSyntax));
	}
	else
	{
		s_currentSyntaxObject = (yyvsp[0].pSyntax);
	}
}
#line 2852 "parser.tab.cpp"
    break;

  case 130: /* SnmpNotificationTypeAssignment: Identifier NOTIFICATION_TYPE_SYM SnmpObjectsPart SnmpAccessPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 998 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-7].pszString);
   (yyval.pObject)->iSyntax = MIB_TYPE_NOTIFTYPE;
   (yyval.pObject)->iAccess = (yyvsp[-4].nInteger);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
   if (isupper((yyval.pObject)->pszName[0]))
   {
      ReportError(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2871 "parser.tab.cpp"
    break;

  case 131: /* SnmpNotificationTypeAssignment: Identifier TRAP_TYPE_SYM ENTERPRISE_SYM LCidentifier SnmpTrapVariablePart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 1018 "parser.y"
{
   MP_SUBID *pSubId;

   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-7].pszString);
   (yyval.pObject)->iSyntax = MIB_TYPE_TRAPTYPE;
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = new ObjectArray<MP_SUBID>(16, 16, Ownership::True);

   pSubId = new MP_SUBID;
   pSubId->pszName = (yyvsp[-4].pszString);
   (yyval.pObject)->oid->add(pSubId);

   pSubId = new MP_SUBID;
   pSubId->pszName = (char *)MemAlloc(strlen((yyvsp[-4].pszString)) + 3);
   sprintf(pSubId->pszName, "%s#0", (yyvsp[-4].pszString));
   pSubId->bResolved = TRUE;
   (yyval.pObject)->oid->add(pSubId);

   for(int i = 0; i < (yyvsp[0].oid)->size(); i++)
      (yyval.pObject)->oid->add((yyvsp[0].oid)->get(i));
   (yyvsp[0].oid)->setOwner(Ownership::False);
   delete (yyvsp[0].oid);

   if (isupper((yyval.pObject)->pszName[0]))
   {
      ReportError(ERR_UPPERCASE_IDENTIFIER, s_currentFilename, g_nCurrLine);
   }
}
#line 2906 "parser.tab.cpp"
    break;

  case 134: /* SnmpTrapVariableList: VARIABLES_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1057 "parser.y"
{
   delete (yyvsp[-1].stringList);
}
#line 2914 "parser.tab.cpp"
    break;

  case 139: /* SnmpMandatoryGroup: MANDATORY_GROUPS_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1074 "parser.y"
{
   delete (yyvsp[-1].stringList);
}
#line 2922 "parser.tab.cpp"
    break;

  case 144: /* SnmpComplianceObject: OBJECT_SYM LCidentifier SnmpSyntaxPart SnmpWriteSyntaxPart SnmpAccessPart SnmpDescriptionPart  */
#line 1095 "parser.y"
{
   MemFreeAndNull((yyvsp[-4].pszString));
   delete_and_null((yyvsp[-3].pSyntax));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2932 "parser.tab.cpp"
    break;

  case 145: /* SnmpComplianceObject: GROUP_SYM LCidentifier SnmpDescriptionPart  */
#line 1101 "parser.y"
{
   MemFreeAndNull((yyvsp[-1].pszString));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 2941 "parser.tab.cpp"
    break;

  case 146: /* SnmpObjectsPart: OBJECTS_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1109 "parser.y"
{
   delete_and_null((yyvsp[-1].stringList));
}
#line 2949 "parser.tab.cpp"
    break;

  case 148: /* SnmpObjectsPart: NOTIFICATIONS_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1114 "parser.y"
{
   delete_and_null((yyvsp[-1].stringList));
}
#line 2957 "parser.tab.cpp"
    break;

  case 151: /* SnmpObjectGroupAssignment: LCidentifier OBJECT_GROUP_SYM SnmpObjectsPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 1128 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->iSyntax = MIB_TYPE_OBJGROUP;
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
}
#line 2971 "parser.tab.cpp"
    break;

  case 152: /* SnmpNotificationGroupAssignment: LCidentifier NOTIFICATION_GROUP_SYM SnmpObjectsPart SnmpStatusPart SnmpDescriptionPart SnmpReferencePart AssignedIdentifier  */
#line 1146 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-6].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-3].nInteger);
   (yyval.pObject)->pszDescription = (yyvsp[-2].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
}
#line 2984 "parser.tab.cpp"
    break;

  case 153: /* ModuleComplianceAssignment: LCidentifier MODULE_COMPLIANCE_SYM SnmpStatusPart SnmpDescriptionPart SnmpReferencePart SnmpModuleComplianceList AssignedIdentifier  */
#line 1163 "parser.y"
{
   MemFreeAndNull((yyvsp[-6].pszString));
   MemFreeAndNull((yyvsp[-3].pszString));
   delete_and_null((yyvsp[0].oid));
}
#line 2994 "parser.tab.cpp"
    break;

  case 157: /* OptionalModuleName: UCidentifier  */
#line 1183 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3002 "parser.tab.cpp"
    break;

  case 163: /* SnmpVariationPart: VARIATION_SYM LCidentifier SnmpSyntaxPart SnmpWriteSyntaxPart SnmpAccessPart SnmpCreationPart SnmpDefValPart SnmpDescriptionPart  */
#line 1207 "parser.y"
{
   MemFreeAndNull((yyvsp[-6].pszString));
   delete_and_null((yyvsp[-5].pSyntax));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3012 "parser.tab.cpp"
    break;

  case 166: /* ModuleCapabilitiesAssignment: SUPPORTS_SYM UCidentifier INCLUDES_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM SnmpVariationsListPart  */
#line 1221 "parser.y"
{
   MemFreeAndNull((yyvsp[-5].pszString));
   delete_and_null((yyvsp[-2].stringList));
}
#line 3021 "parser.tab.cpp"
    break;

  case 167: /* ModuleCapabilitiesAssignment: ModuleIdentifier INCLUDES_SYM SymbolList SnmpVariationsListPart  */
#line 1226 "parser.y"
{
   MemFreeAndNull((yyvsp[-3].pszString));
   delete_and_null((yyvsp[-1].stringList));
}
#line 3030 "parser.tab.cpp"
    break;

  case 168: /* AgentCapabilitiesAssignment: LCidentifier AGENT_CAPABILITIES_SYM PRODUCT_RELEASE_SYM CharString SnmpStatusPart SnmpDescriptionPart SnmpReferencePart ModuleCapabilitiesList AssignedIdentifier  */
#line 1240 "parser.y"
{
   (yyval.pObject) = new MP_OBJECT;
   (yyval.pObject)->iType = MIBC_OBJECT;
   (yyval.pObject)->pszName = (yyvsp[-8].pszString);
   (yyval.pObject)->iStatus = (yyvsp[-4].nInteger);
   (yyval.pObject)->iSyntax = MIB_TYPE_AGENTCAP;
   (yyval.pObject)->pszDescription = (yyvsp[-3].pszString);
   (yyval.pObject)->oid = (yyvsp[0].oid);
   MemFreeAndNull((yyvsp[-5].pszString));
}
#line 3045 "parser.tab.cpp"
    break;

  case 169: /* SnmpAccessPart: ACCESS_SYM LCidentifier  */
#line 1254 "parser.y"
{
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3054 "parser.tab.cpp"
    break;

  case 170: /* SnmpAccessPart: MAX_ACCESS_SYM LCidentifier  */
#line 1259 "parser.y"
{
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3063 "parser.tab.cpp"
    break;

  case 171: /* SnmpAccessPart: MIN_ACCESS_SYM LCidentifier  */
#line 1264 "parser.y"
{
   (yyval.nInteger) = AccessFromText((yyvsp[0].pszString));
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3072 "parser.tab.cpp"
    break;

  case 172: /* SnmpAccessPart: %empty  */
#line 1269 "parser.y"
{
   (yyval.nInteger) = 0;
}
#line 3080 "parser.tab.cpp"
    break;

  case 173: /* SnmpStatusPart: STATUS_SYM LCidentifier  */
#line 1276 "parser.y"
{
   static const char *pStatusText[] = { "mandatory", "optional", "obsolete", "deprecated", "current", NULL };
   int i;

   for(i = 0; pStatusText[i] != NULL; i++)
      if (!stricmp(pStatusText[i], (yyvsp[0].pszString)))
      {
         (yyval.nInteger) = i + 1;
         break;
      }
   if (pStatusText[i] == nullptr)
   {
      char szBuffer[256];
      sprintf(szBuffer, "Invalid STATUS value \"%s\"", (yyvsp[0].pszString));
      mperror(szBuffer);
   }
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3103 "parser.tab.cpp"
    break;

  case 176: /* SnmpReferenceStatement: REFERENCE_SYM CharString  */
#line 1303 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3111 "parser.tab.cpp"
    break;

  case 177: /* SnmpDisplayHintStatement: DISPLAY_HINT_SYM CharString  */
#line 1310 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3119 "parser.tab.cpp"
    break;

  case 178: /* SnmpIndexPart: INDEX_SYM LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1317 "parser.y"
{
   (yyval.stringList) = (yyvsp[-1].stringList);
}
#line 3127 "parser.tab.cpp"
    break;

  case 179: /* SnmpIndexPart: AUGMENTS_SYM LEFT_BRACE_SYM DefinedValue RIGHT_BRACE_SYM  */
#line 1321 "parser.y"
{
   MemFreeAndNull((yyvsp[-1].pszString));
   (yyval.stringList) = nullptr;
}
#line 3136 "parser.tab.cpp"
    break;

  case 180: /* SnmpIndexPart: %empty  */
#line 1326 "parser.y"
{
	(yyval.stringList) = nullptr;
}
#line 3144 "parser.tab.cpp"
    break;

  case 183: /* SnmpDefValPart: DEFVAL_SYM LEFT_BRACE_SYM CharString RIGHT_BRACE_SYM  */
#line 1335 "parser.y"
{
   MemFreeAndNull((yyvsp[-1].pszString));
}
#line 3152 "parser.tab.cpp"
    break;

  case 184: /* SnmpDefValPart: DEFVAL_SYM LEFT_BRACE_SYM Identifier RIGHT_BRACE_SYM  */
#line 1339 "parser.y"
{
   MemFreeAndNull((yyvsp[-1].pszString));
}
#line 3160 "parser.tab.cpp"
    break;

  case 186: /* SnmpDefValPart: DEFVAL_SYM AssignedIdentifierList  */
#line 1344 "parser.y"
{
   delete_and_null((yyvsp[0].oid));
}
#line 3168 "parser.tab.cpp"
    break;

  case 190: /* DefValListElement: LEFT_BRACE_SYM SymbolList RIGHT_BRACE_SYM  */
#line 1357 "parser.y"
{
   delete_and_null((yyvsp[-1].stringList));
}
#line 3176 "parser.tab.cpp"
    break;

  case 192: /* BinaryString: BSTRING_SYM  */
#line 1365 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3184 "parser.tab.cpp"
    break;

  case 193: /* HexString: HSTRING_SYM  */
#line 1372 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3192 "parser.tab.cpp"
    break;

  case 194: /* CharString: CSTRING_SYM  */
#line 1379 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3200 "parser.tab.cpp"
    break;

  case 195: /* SymbolsFromModuleList: SymbolsFromModuleList SymbolsFromModule  */
#line 1386 "parser.y"
{
	(yyval.pImportList) = (yyvsp[-1].pImportList);
   (yyval.pImportList)->add((yyvsp[0].pImports));
}
#line 3209 "parser.tab.cpp"
    break;

  case 196: /* SymbolsFromModuleList: SymbolsFromModule  */
#line 1391 "parser.y"
{
   (yyval.pImportList) = new ObjectArray<MP_IMPORT_MODULE>(16, 16, Ownership::True);
   (yyval.pImportList)->add((yyvsp[0].pImports));
}
#line 3218 "parser.tab.cpp"
    break;

  case 197: /* SymbolsFromModule: SymbolList FROM_SYM UCidentifier  */
#line 1399 "parser.y"
{
   (yyval.pImports) = new MP_IMPORT_MODULE((yyvsp[0].pszString), (yyvsp[-2].stringList));
}
#line 3226 "parser.tab.cpp"
    break;

  case 198: /* SymbolList: SymbolList COMMA_SYM Symbol  */
#line 1406 "parser.y"
{
   (yyval.stringList)->add((yyvsp[0].pszString));
}
#line 3234 "parser.tab.cpp"
    break;

  case 199: /* SymbolList: Symbol  */
#line 1410 "parser.y"
{
   (yyval.stringList) = new Array(16, 16, Ownership::True);
   (yyval.stringList)->add((yyvsp[0].pszString));
}
#line 3243 "parser.tab.cpp"
    break;

  case 200: /* Symbol: UCidentifier  */
#line 1418 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3251 "parser.tab.cpp"
    break;

  case 201: /* Symbol: LCidentifier  */
#line 1422 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3259 "parser.tab.cpp"
    break;

  case 202: /* Symbol: IMPLIED_SYM LCidentifier  */
#line 1426 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3267 "parser.tab.cpp"
    break;

  case 203: /* SequenceItem: Identifier Type  */
#line 1433 "parser.y"
{
   MemFreeAndNull((yyvsp[-1].pszString));
   delete_and_null((yyvsp[0].pSyntax));
}
#line 3276 "parser.tab.cpp"
    break;

  case 211: /* SnmpTypeTagItem: LEFT_BRACKET_SYM UCidentifier Number RIGHT_BRACKET_SYM  */
#line 1460 "parser.y"
{
   MemFreeAndNull((yyvsp[-2].pszString));
}
#line 3284 "parser.tab.cpp"
    break;

  case 222: /* Value: CharString  */
#line 1480 "parser.y"
{
   MemFreeAndNull((yyvsp[0].pszString));
}
#line 3292 "parser.tab.cpp"
    break;

  case 223: /* Identifier: UCidentifier  */
#line 1487 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3300 "parser.tab.cpp"
    break;

  case 224: /* Identifier: LCidentifier  */
#line 1491 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3308 "parser.tab.cpp"
    break;

  case 225: /* UCidentifier: UCASEFIRST_IDENT_SYM  */
#line 1498 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3316 "parser.tab.cpp"
    break;

  case 226: /* LCidentifier: LCASEFIRST_IDENT_SYM  */
#line 1505 "parser.y"
{
   (yyval.pszString) = (yyvsp[0].pszString);
}
#line 3324 "parser.tab.cpp"
    break;


#line 3328 "parser.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1518 "parser.y"


MP_MODULE *ParseMIB(const TCHAR *fileName)
{
   m_pModule = nullptr;
   mpin = _tfopen(fileName, _T("r"));
   if (mpin != nullptr)
   {
#ifdef UNICODE
	  WideCharToMultiByteSysLocale(fileName, s_currentFilename, MAX_PATH);
#else
	  s_currentFilename = fileName;
#endif
      g_nCurrLine = 1;
      InitStateStack();
      /*mpdebug=1;*/
      ResetScanner();
      mpparse();
      fclose(mpin);
   }
   else
   {
#ifdef UNICODE
      char *name = MBStringFromWideString(fileName);
      ReportError(ERR_CANNOT_OPEN_FILE, name, strerror(errno));
      MemFree(name);
#else
      ReportError(ERR_CANNOT_OPEN_FILE, fileName, strerror(errno));
#endif
      return nullptr;
   }
   return m_pModule;
}

extern "C" int mpwrap()
{
	return 1;
}

int mperror(const char *pszMsg)
{
   ReportError(ERR_PARSER_ERROR, s_currentFilename, pszMsg, g_nCurrLine);
   return 0;
}
